/////////////////////////////////////////////////////////////////////////
//
// CDockingWnd            
//
// Created: Mar 12, 2001
// Last Modified: August 03, 2000
//
/////////////////////////////////////////////////////////////////////////
// Copyright (C) 2001 by Greg Winkler, Intelligent Systems Inc.
// (docking_windows@intelligentsystems.net)
//
// All rights reserved.
//
// This code is free for personal and commercial use, providing this 
// notice remains intact in the source files and all eventual changes are
// clearly marked with comments.
//
// You must obtain the author's consent before you can include this code
// in a software library.
//
// No warrantee of any kind, express or implied, is included with this
// software; use at your own risk, responsibility for damages (if any) to
// anyone resulting from the use of this software rests entirely with the
// user.
//
// Send bug reports, bug fixes, enhancements, requests, flames, etc. for
// the docking window code to cristi@datamekanix.com or post them 
// at the message board at the site.
//
// Send bug reports, bug fixes, enhancements, requests, flames, etc. for
// this code to docking_windows@intelligentsystems.net.
//
/////////////////////////////////////////////////////////////////////////
/*///////////////////////////////////////////////////////////////////////

    Description:

    This is a modified version of the CDockingWnd code from Cristi Posea's 
    sample code.

    He asked me if I could get the docking window code to contain
    an ActiveX control, so I tweaked his code so that you can now embed
    a control (I used ActiveMovie) into a docking 
    window you can tear out of the containing control.
    
/*///////////////////////////////////////////////////////////////////////
#if !defined(__DOCKING_WND_H__)
#define __DOCKING_WND_H__

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
/// Uncomment the _USE_ACTIVE_MOVIE_CTRL_ define to have the docking window
/// contain the ActiveMovie ActiveX control
///
/////////////////////////////////////////////////////////////////////////////
#define _USE_ACTIVE_MOVIE_CTRL_

#ifndef _USE_ACTIVE_MOVIE_CTRL_
#define _USE_EDIT_CTRL_         /// otherwise, it defaults to a simple edit
#endif

#ifdef _USE_ACTIVE_MOVIE_CTRL_
/////////////////////////////////////////////////////////////////////////////
/// The simple way to get the interfaces to the ActiveMovie control
/////////////////////////////////////////////////////////////////////////////
#import <msdxm.ocx>  raw_interfaces_only, raw_native_types, named_guids, no_namespace rename("IServiceProvider", "IServiceProviderX" )
#endif /// #ifdef _USE_ACTIVE_MOVIE_CTRL_


#ifndef baseCDockingWnd
#define baseCDockingWnd CSizingControlBarG
#endif

class CDockingWnd : public baseCDockingWnd
{

public:
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDockingWnd)
	//}}AFX_VIRTUAL

public:
	CDockingWnd();
	virtual ~CDockingWnd();

protected:
	CEdit	m_wndChild;
	CFont	m_font;

protected:
	//{{AFX_MSG(CDockingWnd)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

#ifdef _USE_ACTIVE_MOVIE_CTRL_
    /////////////////////////////////////////////////////////////////////////
    /// I call 'CreateControl' on m_AMControl to dynamically create the 
    /// ActiveMovie object, then call GetControlUnknown() to get
    /// IUnknown on it, then persist the IMediaPlayer interface to it in 
    /// m_pMediaPlayer (it's a smart pointer, so I don't need to release it).
    ///
    /// See the OnReadyStateChange() code for an explaination of the 
    /// event mechanisms I needed to implement for the AM control
    /////////////////////////////////////////////////////////////////////////
    CWnd                m_AMControl;
    IMediaPlayerPtr     m_pMediaPlayer;
 
    /////////////////////////////////////////////////////////////////////////
    /// Event sink handler for the AM control
    /////////////////////////////////////////////////////////////////////////
    afx_msg void OnReadyStateChange( MPReadyStateConstants p_iState );
    
    DECLARE_EVENTSINK_MAP( )
#endif
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(__MYBAR_H__)
